#!/bin/bash

main() {

	# Configuration
	CXX="g++"
	CXXFLAGS="-std=c++03 -DMINIZ_NO_ARCHIVE_APIS -Di386 -Wall -Wno-strict-aliasing -Wno-missing-braces -O3 -s -march=native -mtune=native"
	
	if [ $(uname -o) == "Cygwin" ] ; then
		OUTNAME="crype.exe"
	else
		OUTNAME="crype"
	fi
	
	SOURCES=(
		main.cpp
		ccrype.cpp
		vendor/chacha/chacha-merged.cpp
		vendor/miniz/miniz.cpp
		vendor/pbkdf2_sha1/sha1.cpp
		vendor/pbkdf2_sha1/sha1-pbkdf2.cpp
	)

	# Build

	if [ "$1" == "clean" ] ; then
		rm ${OUTNAME}
		
	elif [ "$1" == "install" ] ; then
		cp ${OUTNAME} /usr/local/bin/${OUTNAME}
	
	elif [ "$1" == "uninstall" ] ; then
		rm /usr/local/bin/${OUTNAME}
	
	else
		${CXX} ${CXXFLAGS} ${SOURCES[@]} -o ${OUTNAME}
		
	fi

}

main "$1"
