/**
* crype
* Copyright (c) 2014, The crype Authors
*
* Permission to use, copy, modify, and/or distribute this software for any purpose with
*  or without fee is hereby granted, provided that the above copyright notice and this
*  permission notice appear in all copies.
*/

#include <cstdio>
#include <vector>
#include <string>

#define CRYPE_KEYSIZE_BITS 256
#define CRYPE_ENCKEY_MEMBER_SIZE ((CRYPE_KEYSIZE_BITS / 8)*2)

struct crype {
public:
	crype();
	
	void set_encryption_key(std::string& pass_str);
	void set_compression_level(int compression_level);
	bool encrype();
	bool decrype(bool header_only);

	FILE *in, *out;
	std::string header;

	typedef std::vector<unsigned char> buff_t;

	unsigned int total_chains;

protected:

	void handle_enc(buff_t& buff);
	void handle_zip_enc(buff_t& buff);
	void handle_unzip(buff_t& chain);
	void handle_chain_unzip_enc(buff_t& buff);

	unsigned char enckey[CRYPE_ENCKEY_MEMBER_SIZE];
	int compression_level;
};
